module.exports = {
    docs: [
        {
            type: "doc",
            id: "introduction",
        },
        {
            type: "category",
            label: "Using FAST Components",
            items: [
                "fast-foundation/getting-started",
                {
                    type: "category",
                    label: "Components",
                    items: [
                        "fast-foundation/fast-anchor",
                        "fast-foundation/fast-badge",
                        "fast-foundation/fast-button",
                        "fast-foundation/fast-card",
                        "fast-foundation/fast-checkbox",
                        "fast-foundation/fast-design-system-provider",
                        "fast-foundation/fast-dialog",
                        "fast-foundation/fast-divider",
                        "fast-foundation/fast-flipper",
                        "fast-foundation/fast-menu",
                        "fast-foundation/fast-menu-item",
                        "fast-foundation/fast-progress",
                        "fast-foundation/fast-radio",
                        "fast-foundation/fast-radio-group",
                        "fast-foundation/fast-slider",
                        "fast-foundation/fast-slider-label",
                        "fast-foundation/fast-switch",
                        "fast-foundation/fast-tabs",
                        "fast-foundation/fast-text-area",
                        "fast-foundation/fast-text-field",
                    ],
                },
                {
                    type: "category",
                    label: "Styling Components",
                    items: [
                        "fast-components/intro",
                        "fast-components/design-system",
                        "fast-components/type-ramp",
                        "fast-components/color",
                        "fast-components/match-media-stylesheets",
                    ],
                },
                {
                    type: "category",
                    label: "Integrations",
                    items: [
                        "fast-foundation/aspnet",
                        "fast-foundation/aurelia",
                        "fast-foundation/blazor",
                        "fast-foundation/webpack",
                    ],
                },
            ],
        },
        {
            type: "category",
            label: "Using FAST Element",
            items: [
                "fast-element/getting-started",
                "fast-element/defining-elements",
                "fast-element/declaring-templates",
                "fast-element/using-directives",
                "fast-element/observables-and-state",
                "fast-element/working-with-shadow-dom",
                "fast-element/leveraging-css",
                "fast-element/next-steps",
            ],
        },
        {
            type: "category",
            label: "API Reference",
            items: [
                "api/fast-element",
                "api/fast-foundation",
                "api/fast-components",
                "api/fast-components-msft",
            ],
        },
        {
            type: "category",
            label: "Community Contribution",
            items: [
                "community/join",
                "community/code-of-conduct",
                "community/contributor-guide",
                "community/writing-documentation",
            ],
        },
        {
            type: "category",
            label: "Resources",
            items: [
                "resources/license",
                "resources/security",
                "resources/browser-support",
                "resources/acknowledgements",
                "resources/glossary",
                "resources/faq",
            ],
        },
    ],
};
